#include <time.h> /* clock_gettime(), nanosleep(), timespec */
#include "common.h"
#include "basetime.h"

struct base_time {
  struct timespec time;
};

BaseTime *baseTime_new(void)
{
  return XMALLOC(BaseTime, 1);
}

void baseTime_delete(BaseTime *t)
{
  XFREE(t);
}

void baseTime_get(BaseTime *t)
{
  clock_gettime(CLOCK_REALTIME, &(t->time));
}

void baseTime_set(BaseTime *dst, BaseTime *src)
{
  *dst = *src;
}

int baseTime_subtract_msec(BaseTime *t1, BaseTime *t2)
{
  int dt;

  dt = (int)((t1->time.tv_sec-t2->time.tv_sec)*1000+
             (t1->time.tv_nsec-t2->time.tv_nsec)/1000000);
  return dt;
}

void baseTime_sleep_msec(int dt)
{
  struct timespec req, rem;

  req.tv_sec = dt/1000;
  req.tv_nsec = (dt%1000)*1000000;
  nanosleep(&req, &rem);
}
