#if !defined CMSIMAGE_H
#define CMSIMAGE_H

#include "imageset.h"
#include "cmsprofile.h"

typedef enum cmsIntent CmsIntent;

enum cmsIntent {
  CMS_INTENT_PERCEPTUAL,
  CMS_INTENT_ABSOLUTE_COLORIMETRIC,
  CMS_INTENT_RELATIVE_COLORIMETRIC,
  CMS_INTENT_SATURATION,
  CMS_INTENT_UNKNOWN
};

Image *image_transform_new(Image *image_in, CmsProfile *profile_in, CmsProfile *profile_out, CmsIntent intent);
void image_transform_data(Image *image_in, CmsProfile *profile_in, Image *image_out, CmsProfile *profile_out, CmsIntent intent);
void image_transform_palette(Image *image_in, CmsProfile *profile_in, Image *image_out, CmsProfile *profile_out, CmsIntent intent);

void cms_data_transform(unsigned char *data_in, ImageType type_in, CmsProfile *profile_in, unsigned char *data_out, ImageType type_out, CmsProfile *profile_out, CmsIntent intent, unsigned int len);

#endif /* !CMSIMAGE_H */
