#if !defined CMSPROFILE_H
#define CMSPROFILE_H

#if !defined TRUE
#define TRUE !0
#define FALSE 0
#endif /* !TRUE */

typedef struct cmsProfile CmsProfile;

CmsProfile *cmsProfile_open_mem(void *ptr, size_t len);
CmsProfile *cmsProfile_open_file(const char *filename);
CmsProfile *cmsProfile_open_sRGB(void);
CmsProfile *cmsProfile_open_chromaticities_gamma(double white_x, double white_y,
                                                 double red_x, double red_y,
                                                 double green_x, double green_y,
                                                 double blue_x, double blue_y,
                                                 double *gamma_of_file, int num);
CmsProfile *cmsProfile_open_chromaticities(double white_x, double white_y,
                                           double red_x, double red_y,
                                           double green_x, double green_y,
                                           double blue_x, double blue_y,
                                           unsigned short *gamma_tables[],
                                           int num_tables,
                                           int num_samples);
CmsProfile *cmsProfile_open_temp(int tempK, double *gamma_of_file, int num);
int cmsProfile_close(CmsProfile *profile);

#endif /* !CMSPROFILE_H */
