#if !defined COMMON_H
#define COMMON_H

#if defined HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#if !defined EXIT_SUCCESS
#define EXIT_SUCCESS 0
#define EXIT_FAILURE !0
#endif /* !EXIT_SUCCESS */

#if !defined TRUE
#define TRUE !0
#define FALSE 0
#endif /* !TRUE */

#if defined __cplusplus
#define BEGIN_C_DECLS extern "C" {
#define END_C_DECLS   }
#else
#define BEGIN_C_DECLS
#define END_C_DECLS
#endif /* __cplusplus */

#if defined DEBUG
#define DEBUG_PRINT(...) do { fprintf(stdout, "%s:%d: ", __FILE__, __LINE__); fprintf(stdout, __VA_ARGS__); } while(0)
#else
#define DEBUG_PRINT(...)
#endif /* DEBUG */

#define XCALLOC(type, num) ((type *)calloc((num), sizeof(type)))
#define XMALLOC(type, num) ((type *)malloc((num)*sizeof(type)))
#define XREALLOC(type, p, num) ((type *)realloc((p), (num)*sizeof(type)))
#define XFREE(stale) do { if (stale != NULL) { free(stale); stale = NULL; } } while(0)

#endif /* !COMMON_H */
